﻿using System;
using System.Threading;
using System.Windows.Forms;


    public partial class Form1 : Form
    {
    private SKSampleClass SK_Controller = new SKSampleClass();
    public Form1()
        {
            InitializeComponent();
        }

    private void Form1_Load(object sender, EventArgs e)
    {
        string[] ports = SK_Controller.GetPortNames();
        ComboBox1.Items.AddRange(ports);
        SK_Controller.CurPosLabel = this.Label_Position_0;
        groupBox1.Enabled = false;
        groupBox3.Enabled = false;
        Button2.Enabled = false;
        Button4.Enabled = false;

    }

    // Connect To Port
    private void Button1_Click(object sender, EventArgs e)
    {

        if (!(ComboBox1.SelectedItem is object) || !(ComboBox2.SelectedItem is object))

        {
            MessageBox.Show(" Please Select Port Settings", " Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            return;
        }
        SK_Controller.PortName = ComboBox1.Text;
        SK_Controller.Baudrate = Convert.ToInt32(ComboBox2.Text);
        if (SK_Controller.ConnectTest()==false)
        {
            MessageBox.Show(" Com port or Model selected is unknown", "Device Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            SK_Controller.PortClose();
            return;
        }
        if (SK_Controller.Set_Model_Controller() == false)
        {
            MessageBox.Show(" Com port or Model selected is unknown", "Device Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            SK_Controller.PortClose();
            return;
        }
        ProgressBar1.Value = 100;
        Button1.Enabled = false;
        groupBox1.Enabled = true;
        groupBox3.Enabled = true;
        Button2.Enabled = true;
        Button4.Enabled = true;
        ComboBox1.Enabled = false;
        ComboBox2.Enabled = false;
        comboBox3.SelectedIndex = 0;
        
    }
    // Close Port
    private void Button2_Click(object sender, EventArgs e)
    {
        SK_Controller.PortClose();
        Button1.Enabled = true;
        Button2.Enabled = false;
        groupBox1.Enabled = false;
        Button4.Enabled = false;
        ProgressBar1.Value = 0;
        ComboBox1.Enabled = true;
        ComboBox2.Enabled = true;
    }
    // Write FC series commands
    private void Button3_Click(object sender, EventArgs e)
    {
        string SCommand = TextBox1.Text;
        string RCommand;
        RCommand = string.Empty;

        SK_Controller.SGWrite(SCommand);
        Thread.Sleep(200);

        if (SK_Controller.SK_SerialPort.BytesToRead== 0)
        {
            return;
        }
        SK_Controller.SGRead(ref RCommand);

        if (RCommand != "")
        {
            TextBox2.Text = TextBox2.Text + RCommand;
            RCommand = "";
        }
    }
    // Home Command Axis  ( Current Position)
    private void Button4_Click(object sender, EventArgs e)
    {


        if (comboBox3.SelectedIndex == 0)
        {
            SK_Controller.ReturnOrigin(1);
            SK_Controller.MoveRelativity(0, 1000);
        }
        else if (comboBox3.SelectedIndex == 1)
        {
            SK_Controller.ReturnOrigin(2);
        }
        else
        {
            SK_Controller.ReturnOrigin(0);
        }
    }
}

